﻿using System;
using System.Text;

public class Class1
{
    #region 이진 문자열 구하기 - GetBinaryString(sourceValue)

    /// <summary>
    /// 이진 문자열 구하기
    /// </summary>
    /// <param name="sourceValue">소스 값</param>
    /// <returns>이진 문자열</returns>
    public static string GetBinaryString(int sourceValue)
    {
        int temporaryValue = sourceValue;

        byte[] temporaryArray = new byte[32];

        for (int i = 0; i < 32; i++)
        {
            if ((temporaryValue & 0x01) == 0x01)
            {
                temporaryArray[i] = 1;
            }
            else
            {
                temporaryArray[i] = 0;
            }

            temporaryValue = (temporaryValue >> 1);
        }

        StringBuilder stringBuilder = new StringBuilder();

        for (int i = 1; i <= 32; i++)
        {
            stringBuilder.Append(temporaryArray[32 - i]);

            if (i % 4 == 0)
            {
                stringBuilder.Append(" ");
            }
        }

        return stringBuilder.ToString();
    }

    #endregion
    #region 이진 문자열 구하기 - GetBinaryString(sourceValue)

    /// <summary>
    /// 이진 문자열 구하기
    /// </summary>
    /// <param name="sourceValue">소스 값</param>
    /// <returns>이진 문자열</returns>
    public unsafe static string GetBinaryString(float sourceValue)
    {
        float temporaryValue = sourceValue;

        byte[] temporaryArray = new byte[32];

        unsafe
        {
            int* pointer = (int*)(&temporaryValue);

            for (int i = 0; i < 32; i++)
            {
                if ((*pointer & 0x01) == 0x01)
                {
                    temporaryArray[i] = 1;
                }
                else
                {
                    temporaryArray[i] = 0;
                }

                *pointer = (*pointer >> 1);
            }

            StringBuilder stringBuilder = new StringBuilder();

            for (int i = 1; i <= 32; i++)
            {
                stringBuilder.Append(temporaryArray[32 - i]);

                if (i % 4 == 0)
                {
                    stringBuilder.Append(" ");
                }
            }

            return stringBuilder.ToString();
        }
    }

    #endregion
    #region 이진 문자열 구하기 - GetBinaryString(sourceValue)

    /// <summary>
    /// 이진 문자열 구하기
    /// </summary>
    /// <param name="sourceValue">소스 값</param>
    /// <returns>이진 문자열</returns>
    public unsafe static string GetBinaryString(double sourceValue)
    {
        double temporaryValue = sourceValue;

        byte[] temporaryArray = new byte[64];

        unsafe
        {
            long* pointer = (long*)(&temporaryValue);

            for (int i = 0; i < 64; i++)
            {
                if ((*pointer & 0x01) == 0x01)
                {
                    temporaryArray[i] = 1;
                }
                else
                {
                    temporaryArray[i] = 0;
                }

                *pointer = (*pointer >> 1);
            }

            StringBuilder stringBuilder = new StringBuilder();

            for (int i = 1; i <= 64; i++)
            {
                stringBuilder.Append(temporaryArray[64 - i]);

                if (i % 4 == 0)
                {
                    stringBuilder.Append(" ");
                }
            }

            return stringBuilder.ToString();
        }
    }

    #endregion

}